<?php
/**
	Widget - Yahoo Weather 1.0

	@package Zourbuth
	@subpackage Classes
	http://zourbuth.com/plugins/yahoo-weather
	For another improvement, you can drop email to zourbuth@gmail.com or visit http://zourbuth.com
	Parameter 		Description 								Example
	---------------------------------------------------------------------
	w 				woeid 										w=2502265
	u 				Units for temperature (case sensitive)
	f: Fahrenheit
	c: Celsius
	---------------------------------------------------------------------
	Example
	http://weather.yahooapis.com/forecastrss?w=2442047&u=c
*/



/**
 * SimplePie function for handling feed, extract the items, items images, items description,
 * items link and the bla and the bla and the bla. Making cache for best performance,
 * and content modification. Ok, so we start from here, please watch and be carefull mate!
 */
function yahoo_weather_simplepie( $woeid = '2459115', $temperature = 'c', $show_credit = true, $echo = true ) {
	if( function_exists('fetch_feed') ) {
		
		require_once ( ABSPATH . WPINC . '/class-simplepie.php' );
		require_once ( trailingslashit( YAHOO_WEATHER_DIR ) . 'simplepie_yahoo_weather.inc');
		
		$feed = new SimplePie();
		
		/* specify the feed source */
		$param = 'http://weather.yahooapis.com/forecastrss?w=' . $woeid . '&u=' . $temperature;
		//$param = YAHOO_WEATHER_URL . 'forecastrss.xml';
		
		$feed->set_feed_url( $param );

		$feed->set_cache_location( YAHOO_WEATHER_DIR . 'cache');
		
		$feed->set_item_class('SimplePie_Item_YWeather');
		
		// Initialize the feed
		$feed->init();
		 
		// Since Y! Weather feeds only have one item, we'll base everything around that.
		$weather = $feed->get_item(0);

		/**
		 * if the feed is broken, or having problem to get the feed
		 * and maybe there is no item in the feed then print the 'content'
		 */
		
		foreach ( $weather->get_forecasts() as $forecast ):
			$date	= $forecast->get_date('l, F jS');
			$low	= $forecast->get_low(); 
			$high	= $forecast->get_high();
			$label 	= $forecast->get_label();
		endforeach;
		
		// rising: state of the barometric pressure: steady (0), rising (1), or falling (2). (integer: 0, 1, 2)
		$rising = $weather->get_rising();
		if ( $rising == 0 )
			$rising = __('steady', 'yahoo-weather');
		elseif ( $rising == 1 )
			$rising = __('rising', 'yahoo-weather');
		elseif ( $rising == 2 )
			$rising = __('falling', 'yahoo-weather');
		
		$content .= '<p class="last-update">' . __('Current conditions for ', 'yahoo-weather') . $weather->get_city() . __(' as of ', 'yahoo-weather') . $weather->get_last_updated( $format ) . '</p>';
		
		$content .= '<div class="forecast-icon">';
			$content .= '<img src="http://l.yimg.com/a/i/us/nws/weather/gr/' . $weather->get_condition_code() . 'd.png" alt="' . $weather->get_condition() . '" />';
			$content .= '<p class="temperature">' . $weather->get_temperature() . '&deg;</p>';
			$content .= '<p class="high-low">High: ' . $high . '&deg; Low: ' . $low . '&deg;</p>';
		$content .= '</div>';
		
		$content .= '<p class="condition">' . $weather->get_condition() . '</p>';
		$content .= '<p class="y-temperature">' . __('Feels like: ', 'yahoo-weather') . $weather->get_temperature() . ' &deg;' . $weather->get_units_temp() . '</p>';
		$content .= '<p class="pressure">' . __('Barometer: ', 'yahoo-weather') . $weather->get_pressure() . ' ' . $weather->get_units_pressure() . ' and ' . $rising . '</p>';
		$content .= '<p class="pressure">' . __('Humidity: ', 'yahoo-weather') . $weather->get_humidity() . '%</p>';
		$content .= '<p class="pressure">' . __('Visibility: ', 'yahoo-weather') . $weather->get_visibility() . ' ' . $weather->get_units_distance() . '</p>';
		$content .= '<p class="pressure">' . __('Dewpoint: ', 'yahoo-weather') . $low . ' &deg;' . $weather->get_units_temp() . '</p>';
		$content .= '<p class="pressure">' . __('Wind: ', 'yahoo-weather') . $weather->get_wind_speed() . ' ' . $weather->get_units_speed() . '</p>';
		$content .= '<p class="pressure">' . __('Sunrise: ', 'yahoo-weather') . $weather->get_sunrise() . '</p>';
		$content .= '<p class="pressure">' . __('Sunset: ', 'yahoo-weather') . $weather->get_sunset() . '</p>';
		
		if ( $show_credit ) $credit = ' & <a href="http://zourbuth.com/plugins/yahoo-weather/">zourbuth.com</a>';
		$content .= '<span class="copyright">Powered by <a href="http://weather.yahoo.com/">Yahoo! Weather</a>' . $credit . '</span>';

		
		/* if echo is true print the content out, else return it */
		if ( $echo ) echo $content;
		else return $content;
	}
}




/**
 * deviantART Widget Widget
 * extends WP_Widget
 * function Z_deviantART_Widget()
 * function yahoo_weather_style()
 * function update($new_instance, $old_instance)
 * function form($instance)
 */
class Yahoo_Weather_Forecasts_Pl461n extends WP_Widget {

	function __construct() {

		/* load the widget stylesheet for the widgets screen. */
		add_action( 'load-widgets.php', array(&$this, 'yahoo_weather_style') );
		
		/* ddd some informations to the widget */
		$widget_options = array('classname' => 'yahoo_weather_forecast', 'description' => __( 'Show the location weather using Yahoo! Weather.', $this->textdomain ) );

		/* set up the widget control options. */
		$control_options = array(
			'width' 	=> 520,
			'height' 	=> 350,
		);	
		
		/* create the widget with controls and options given above */
		$this->WP_Widget('yahoo-weather-forecast', 'Yahoo! Weather Forecasts', $widget_options, $control_options);
		
		if ( is_active_widget(false, false, $this->id_base) ) {
			wp_enqueue_style( 'yahoo-weather-forecast', YAHOO_WEATHER_URL . 'css/widget.css' );		
			wp_enqueue_script( 'jquery' );
			add_action( 'wp_head', array(&$this, 'yahoo_weather_costum_style_script')); // print the user costum style sheet
		}
	}

	/* push the widget stylesheet widget.css */
	function yahoo_weather_style() {
		wp_enqueue_style( 'yahoo_weatheroptions', YAHOO_WEATHER_URL . 'css/admin.css', false, 0.7, 'screen' );
	}	

	/** print the user stylesheet and script **/
	function yahoo_weather_costum_style_script() {
	/* Print the custom script-style to the header wp_head */
		$all_widgets = $this->get_settings();
		foreach ($all_widgets as $key => $yw_setting){
			$widget_id = $this->id_base . '-' . $key;
			if( is_active_widget( false, $widget_id, $this->id_base ) ){
				if ( !empty( $yw_setting['customstylescript'] ) )
					echo $yw_setting['customstylescript'];
			}
		}		
	}
	
	/**
	 * Outputs the widget based on the arguments input through the widget controls.
	 * @since 0.6.0
	 */
	function widget( $args, $instance ) {
		extract( $args );

		/** Set up the arguments **/
		$args = array(
			'woeid'				=> intval( $instance['woeid'] ),
			'temperature'		=> intval( $instance['temperature'] ),
			'show_credit'		=> !empty( $instance['show_credit'] ) ? true : false,
			'intro_text' 		=> $instance['intro_text'],
			'outro_text' 		=> $instance['outro_text'],
			'customstylescript'	=> $instance['customstylescript']
		); 
		
		echo $before_widget;
		
		/* If a title was input by the user, display it. */
		if ( !empty( $instance['title'] ) )
			echo $before_title . apply_filters( 'widget_title',  $instance['title'], $instance, $this->id_base ) . $after_title;

		/* Print intro text if exist */
		if ( !empty( $instance['intro_text'] ) )
			echo '<p class="intro-text">' . $instance['intro_text'] . '</p>';
		
		echo '<div class="yahoo-weather">'; // open the block
			yahoo_weather_simplepie( $instance['woeid'], $instance['temperature'], $instance['show_credit'], true ); // processing the feed
		echo '</div>'; // close block
		
		/* Print outro text if exist */
		if ( !empty( $instance['outro_text'] ) )
			echo '<p class="outro_text">' . $instance['outro_text'] . '</p>';

		echo $after_widget;
	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;

		/* Set the instance to the new instance. */
		$instance = $new_instance;
		$instance['woeid'] 			= strip_tags( $new_instance['woeid'] );
		$instance['temperature'] 	= strip_tags( $new_instance['temperature'] );
		$instance['show_credit'] 	= ( isset( $new_instance['show_credit'] ) ? 1 : 0 );
		$instance['intro_text'] 	= $new_instance['intro_text'];
		$instance['outro_text'] 	= $new_instance['outro_text'];
		$instance['customstylescript']	= $new_instance['customstylescript'];
		return $instance;
	}	

	/** Displays the widget control options in the Widgets admin screen. **/
	function form( $instance ) {

		/** Set up the default form values. **/
		$defaults = array(
			'title' 			=> 'Yahoo! Weather Forecasts',
			'woeid' 			=> '',
			'temperature' 		=> 'c',
			'show_credit'		=> true,
			'intro_text' 		=> '',
			'outro_text' 		=> '',
			'customstylescript'	=> ''
		);

		/** Merge the user-selected arguments with the defaults. **/
		$instance = wp_parse_args( (array) $instance, $defaults );
		$temperature = strip_tags($instance['temperature']);
		$temperature_option = array( 'c' => __( 'Celcius', $this->textdomain ), 'f' => __( 'Fahreinheit', $this->textdomain ) );
	?>

		<div class="zframe-widget-controls columns-2">
			<p>
				<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:', 'premium-widget-pack' ); ?></label>
				<input type="text" class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo esc_attr( $instance['title'] ); ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id( 'woeid' ); ?>"><?php _e( 'WOEID:', $this->textdomain ); ?></label>
				<input type="text" class="widefat" id="<?php echo $this->get_field_id( 'woeid' ); ?>" name="<?php echo $this->get_field_name( 'woeid' ); ?>" value="<?php echo esc_attr( $instance['woeid'] ); ?>" />
				<?php _e( 'Example for New York City:', $this->textdomain ); ?><code>2459115</code><br />
				<?php _e( 'Use  <a href="http://woeid.rosselliot.co.nz">this</a> WOEID lookup.', $this->textdomain ); ?>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id( 'temperature' ); ?>"><?php _e('Temperature', $this->textdomain ) ?></label> 
				<select class="smallfat" id="<?php echo $this->get_field_id( 'temperature' ); ?>" name="<?php echo $this->get_field_name( 'temperature' ); ?>">
					<?php foreach ( $temperature_option as $dataype => $option_label ) { ?>
						<option value="<?php echo esc_attr( $dataype ); ?>" <?php selected( $temperature, $dataype ); ?>><?php echo esc_html( $option_label ); ?></option>
					<?php } ?>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id( 'intro_text' ); ?>"><?php _e('Intro Text:', $this->textdomain ) ?></label><br />
				<textarea name="<?php echo $this->get_field_name( 'intro_text' ); ?>" id="<?php echo $this->get_field_id( 'intro_text' ); ?>" rows="4" class="widefat"><?php echo htmlentities($instance['intro_text']); ?></textarea>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id( 'outro_text' ); ?>"><?php _e('Outro Text:', $this->textdomain ) ?></label><br />
				<textarea name="<?php echo $this->get_field_name( 'outro_text' ); ?>" id="<?php echo $this->get_field_id( 'outro_text' ); ?>" rows="4" class="widefat"><?php echo htmlentities($instance['outro_text']); ?></textarea>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('customstylescript'); ?>"><?php _e( 'Custom Script & Stylesheet :', $this->textdomain ); ?></label><br />
				<?php _e('Selector:', $this->textdomain ); ?> <code>#<?php echo $this->id; ?></code>
				<textarea style="font-size: 11px;" name="<?php echo $this->get_field_name( 'customstylescript' ); ?>" id="<?php echo $this->get_field_id( 'customstylescript' ); ?>" rows="6" class="widefat code"><?php echo htmlentities($instance['customstylescript']); ?></textarea>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id( 'show_credit' ); ?>">
				<input class="checkbox" type="checkbox" <?php checked( $instance['show_credit'], true ); ?> id="<?php echo $this->get_field_id( 'show_credit' ); ?>" name="<?php echo $this->get_field_name( 'show_credit' ); ?>" /> <?php _e( 'Show credit?', $this->textdomain ); ?></label>
			</p>
		</div>
		
		<div class="zframe-widget-controls envato-marketplace columns-2 column-last">	
			<p>Premium WordPress Plugin</p>
			<?php
				require_once 'Envato_marketplaces.php';
				$Envato = new Envato_marketplaces();
				$Envato->display_thumbs('zourbuth', 'codecanyon', '5');
			?>
		</div>
		<div class="clear"></div>
	<?php
	}
}
?>